Subject: Re: [v2] powerpc: mm: fixup preempt undefflow with huge pages

From: Michael Ellerman <[email-masked]>
Date: Thu, 31 Mar 2016 10:29:45 +1100 (AEDT)

On Tue, 2016-08-03 at 09:03:56 UTC, Sebastian Siewior wrote:
> hugepd_free() used __get_cpu_var() once. Nothing ensured that the code
> accessing the variable did not migrate from one CPU to another and soon
> this was noticed by Tiejun Chen in 94b09d755462 ("powerpc/hugetlb:
> Replace __get_cpu_var with get_cpu_var"). So we had it fixed.
> 
> Christoph Lameter was doing his __get_cpu_var() replaces and forgot
> PowerPC. Then he noticed this and sent his fixed up batch again which
> got applied as 69111bac42f5 ("powerpc: Replace __get_cpu_var uses").
> 
> The careful reader will noticed one little detail: get_cpu_var() got
> replaced with this_cpu_ptr(). So now we have a put_cpu_var() which does
> a preempt_enable() and nothing that does preempt_disable() so we
> underflow the preempt counter.
> 
> Cc: Benjamin Herrenschmidt <[email-masked]>
> Cc: Christoph Lameter <[email-masked]>
> Cc: Michael Ellerman <[email-masked]>
> Cc: <[email-masked]>
> Signed-off-by: Sebastian Andrzej Siewior <[email-masked]>
> Reviewed-by: Aneesh Kumar K.V <[email-masked]>

Applied to powerpc fixes, thanks.

https://git.kernel.org/powerpc/c/08a5bb2921e490939f78f38fd0

cheers